----------------------------------------------------------------------------------
--							Memoria RAM  - DE0
--
--	Projeto do cronometro visa utilizar a placa DE0 como um cronometro 
--	com trs botes, um para pausar a contagem, um para parar a contagem
--	e um para resetar. O cronometro conta minutos e segundos e o clock
--	 de 50MHz, por isso h necessidade de fazer um preescaler na de 50MHz
--	para o funcionamento correto. Foram usados os quatro displays de 7 segmentos
--	da placa e os trs botes. No h a possibilidade de mutiplexao dos
--	displays, pois o kit no apresenta pino de enable para os displays e,
--	de certa forma, a multiplexao no  necessria, pois os pinos dos
--	displays esto todos ligados as FPGA. 
--
--	setembro de 2011
--
---------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity cronometro is
port
(
	clock: std_logic;
	resetn, pausa, stop: in std_logic;
	seg_7_1, seg_7_2, seg_7_3, seg_7_4: out STD_LOGIC_vector(0 to 6);
	H : out std_logic
);
end entity;

architecture Contador of cronometro is
	signal min : std_logic_vector(6 downto 0);
	signal seg : std_logic_vector (6 downto 0);

	begin
	H <= '0';
	process(clock, resetn, pausa, stop)
	
	variable cont : integer range 0 to 50000000 :=0;
	variable var_min  : std_logic_vector(6 downto 0) := "0000000";
	variable var_seg : std_logic_vector(6 downto 0) := "0000000";
	variable flag : std_logic := '0';
	
	begin
	
	if stop'event and stop = '0' and flag ='0' then
		flag := '1';
		
	elsif stop'event and stop = '0' and flag = '1' then 
		flag := '0';
		
	end if;
	
	if resetn = '0' then
		var_min := "0000000";
		var_seg := "0000000";
		cont := 0;
		flag := '0';
	
	elsif clock'event and clock = '1' then
		if flag = '0' then
		
			cont := cont + 1;
			if cont = 50000000 then
				cont :=0;
				var_seg := var_seg + "0000001";
				
				if var_seg (3 downto 0) = "1010" then
						var_seg (6 downto 4) := var_seg(6 downto 4) + "001";
						var_seg (3 downto 0) := "0000";
				
					if var_seg(6 downto 4) = "110" then
							var_min := var_min + "0000001";
							var_seg (6 downto 4) := "000";
							
							if var_min (3 downto 0) = "1010" then
								var_min(6 downto 4) := var_min(6 downto 4) + "001";
								var_min(3 downto 0) := "0000";
								
								if var_min(6 downto 0) = "110" then
									var_min(6 downto 0) := "000";
								end if;
							end if;
						end if;
				end if;
			end if;
		end if;
	end if;
	if pausa /= '0' then
		min <= var_min;
		seg <= var_seg;
	end if;
	end process;

	with min (3 downto 0) select
			seg_7_1  <= "0000001" when "0000", 
									  "1001111" when "0001",
									  "0010010" when "0010",	
									  "0000110" when "0011",	
									  "1001100" when "0100",
									  "0100100" when "0101",
									  "0100000" when "0110",
									  "0001111" when "0111",
									  "0000000" when "1000",
									  "0000100" when "1001",	
													
								  "1111111" when others;						
				
	with min (6 downto 4) select
			seg_7_2  <= "0000001" when "000", 
									  "1001111" when "001",
									  "0010010" when "010",	
									  "0000110" when "011",	
									  "1001100" when "100",
									  "0100100" when "101",
									  "0100000" when "110",
									  "0001111" when "111",
													
									  "1111111" when others;
	with seg (6 downto 4) select
			seg_7_3  <= "0000001" when "000", 
									  "1001111" when "001",
									  "0010010" when "010",	
									  "0000110" when "011",	
									  "1001100" when "100",
									  "0100100" when "101",
									  "0100000" when "110",
									  "0001111" when "111",	
													
									  "1111111" when others;
	with seg (3 downto 0) select
			seg_7_4  <= "0000001" when "0000", 
									  "1001111" when "0001",
									  "0010010" when "0010",
									  "0000110" when "0011",	
									  "1001100" when "0100",
									  "0100100" when "0101",
									  "0100000" when "0110",
									  "0001111" when "0111",
									  "0000000" when "1000",
									  "0000100" when "1001",	
													
						  "1111111" when others;
		

end architecture; 